Sequelize = require('sequelize')
pg = require('pg').native;

var databaseUrl = process.env.DATABASE_URL;

if (databaseUrl) {
  var match = databaseUrl.match(/postgres:\/\/([^:]+):([^@]+)@([^:]+):(\d+)\/(.+)/);
  if (!match) { // try without password
    match = databaseUrl.match(/postgres:\/\/([^:]+):@([^:]+):(\d+)\/(.+)/);
  }
  if (!match) {
    throw new Error('DATABASE_URL env variable must be formatted as "postgres://USERNAME:PASSWORD@HOST:PORT/DATABASE"');
  }
  var username = match[1];
  var password = match[2] || "";
  var database = match[5];
  var db = new Sequelize(database, username, password, {
    dialect: 'postgres',
    protocol: 'postgres',
    port: match[4],
    host: match[3],
    logging: false,
    native: true
  }); 
} else {
  throw new Error('DATABASE_URL env variable is required, formatted as "postgres://USERNAME:PASSWORD@HOST:PORT/DATABASE"');
}

module.exports = db; 

